=== debian/changelog ===
ros-foxy-rmf-task (1.0.0-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Yadunund <yadunund@openrobotics.org>  Mon, 13 Sep 2021 02:37:27 -0000
